// pre-pad patterns based on lcm of subdiv??

SwitchBufSeq {
	// manages several patterns for a BufSeq / MultiBufSeq
	
	var	bufseq,		// the player
		<>patterns,
		<>selectpatterns,
		<>patLengths,
//		barpattern,
		defaultQuant,
		switchRoutine;
	
	*new { arg bufseq ... args;
		^super.new.init(bufseq, args);
	}
	
	init { arg bseq, args;
//		var argIndex = 0;
		
		bufseq = bseq;
		
			// get first pattern from bufseq and add patterns from arguments
		patLengths = [bufseq.patLength] ++ args.at(0);
		patterns = [bufseq.pattern] ++ args.at(1);
		bufseq.isKindOf(MultiBufSeq).if({
			selectpatterns = [bufseq.selectpattern] ++ args.at(2);
//			argIndex = 1;
		}, {
			selectpatterns = []
		});
		
	}
	
	add { arg patLens, pats, selpats;
		patLengths = patLengths ++ patLens;
		patterns = patterns ++ pats;
		selectpatterns = selectpatterns ++ selpats;
	}
	
	removeAt { arg i;
		i.isArray.if({
				// must do in reverse order so indices are always right
			i.sort({ arg a, b; a > b });
			i.do({ arg j;
				patLengths.removeAt(j.clip(0, patterns.size-1));
				patterns.removeAt(j.clip(0, patterns.size-1));
				selectpatterns.removeAt(j.clip(0, selectpatterns.size-1));
			});
		}, {
			patLengths.removeAt(i.clip(0, patterns.size-1));
			patterns.removeAt(i.clip(0, patterns.size-1));
			selectpatterns.removeAt(i.clip(0, selectpatterns.size-1));
		});
	}
	
	play { arg pat, quant;
		var args, loopQuant, oldRoutine, barpattern, first, useRoutine = true;
			// fix arguments
			// change single index into array
//["SwitchBufSeq-play", bufseq.clock.elapsedBeats.trunc(0.001), bufseq.thing].asCompileString.postln;
		pat.isKindOf(Integer).if({
			barpattern = [pat];
			useRoutine = false
		}, {
			barpattern = pat
		});
			// change array into Pseq
		barpattern.isArray.if({ barpattern = Pseq(barpattern, inf); });
//		useRoutine = barpattern.isKindOf(Pattern) || barpattern.isKindOf(Stream);
		barpattern = barpattern.asStream;	// and make it a stream
		first = barpattern.next;
		loopQuant = defaultQuant = patLengths.at(first).asTimeSpec;
		args = [defaultQuant.quant, patterns.at(first), quant ? defaultQuant];
		bufseq.isKindOf(MultiBufSeq).if({
			args = args.insert(2, selectpatterns.at(first));
		});
			// now play -- if just pattern number, play that pattern
		useRoutine.not.if({
			bufseq.performList(\pattern_, args);	// args includes quantize info
			bufseq.isPlaying.not.if({ bufseq.play(quant ? defaultQuant); });
		}, {		// otherwise, we need a routine to switch periodically
			quant = quant ? defaultQuant;
				// clear old switcher--but, we have to wait until the new routine starts
			oldRoutine = switchRoutine;
			switchRoutine = Routine({
				var i = 1, pat, lastPat, latency;
//				latency = bufseq.subdiv.reciprocal * 0.9;
				oldRoutine.notNil.if({ oldRoutine.stop });
				bufseq.performList(\pattern_, args);
				bufseq.isPlaying.not.if({ bufseq.play(quant); });
				{
//["switchRoutine awake", i, bufseq.clock.elapsedBeats].postln;
					loopQuant.quant.wait; // bufseq is already playing first pattern, so wait for next
					lastPat = pat;
					pat = barpattern.next;
					(pat != lastPat).if({	// no need to send anything if pattern not changing
						args = [patLengths.at(pat), patterns.at(pat), 
							loopQuant];
						bufseq.isKindOf(MultiBufSeq).if({
							args = args.insert(2, selectpatterns.at(pat));
						});
						bufseq.performList(\pattern_, args);
					});
//					i = i + 1;
				}.loop;
			});
				// bufseq handles precise timing, so we can be loose here
			bufseq.clock.schedAbs(quant.asTimeSpec.schedTime(bufseq.clock) - 2,
				switchRoutine);
		});
	}
	
	stop { arg quant = 1;
//["SwitchBufSeq-stop", bufseq.clock.elapsedBeats.trunc(0.001), bufseq.thing].asCompileString.postln;
		switchRoutine.notNil.if({ /* "stopping routine".postln; */ switchRoutine.stop; });
		bufseq.stop(quant);
	}
	
	free { arg quant = 1;
		this.stop(quant);
		bufseq.free(quant);
	}
	
	size { ^patterns.size }
	
}
