	// some additional methods required for MixerChannel/MixingBoard

+ Dictionary {		// add a couple of methods to Dictionary
		// asSortedArray is now part of the common class library!!!

//	asSortedArray {	// return arrays representing the dict as two arrays,
//					// keys and values, sorted by keys
//		var keys, values;
//		keys = Array.new;	// must change set to array by hand
//		this.keys.do({ arg key; keys = keys.add(key) });
//		keys = keys.sort;
//		values = keys.collect({ arg key; this.at(key) });
//		^[keys, values]
//	}
	
	postSorted {	// post the dictionary in sorted order
		var sorted;
		sorted = this.asSortedArray;
		sorted.do({ arg pair;
			(pair.at(0).asString ++ "\t" ++ pair.at(1)).postln;
		});
			// for command-line use
			// in inline code, this output should be discarded
		^(sorted.size.asString ++ " entries.")
	}
}

+ Bus {
	asMixer {		// returns the mixer if "this" corresponds to a MixerChannel inbus,
				// nil otherwise
		^MixerChannel.servers.at(server).at(index);
	}
}

+ Nil {
	asMixer {}
}

// felix won't like this b/c it "should" be private; but w/ busdict, shared buses have to
// be double-freed which breaks the bus allocator, so this is necessary for MixerChannel
+ SharedBus {
	released_ { arg bool; released = bool }
}