
	// a gui for displaying status messages on a gui window
	// this will be a lot better when SCStaticText has a valign property
	// but it's pretty cool now
	
	// I added some hacks to String-post and -postln, which slows down things just slightly
	// but it's worth it to have the flexibility of displaying main output on the gui
	
	// primitive output and server messaging is not displayed

SCStatusBox : SCStaticTextBase {
	classvar	<default;
	var	<>numLines,
		<>display;
	
	*new { arg argParent, argBounds, argLines;
		^super.new(argParent, argBounds).numLines_(argLines ? 5).display_("")
	}
	
	*viewClass { ^SCStaticText }
	
	remove {
		(default == this).if({ default = nil });	// forget about me if I'm going away
		super.remove;
	}

	post { arg str;
		var	nlPos, lines;
		display = display ++ str;
			// count backward from last char (excluding final cr)
		nlPos = display.size - (display.last == $\n).if(1, 0);
		lines = 0;
		{ nlPos >= 0 and: (lines < numLines) }.while({
			nlPos = nlPos - 1;
			(display[nlPos] == $\n).if({ lines = lines + 1 });
		});
		display = display.copyRange(nlPos + (display[nlPos] == $\n).binaryValue, display.size-1);
		dataptr.notNil.if({ { this.string_(display); nil }.defer; });
	}
	
	postln { arg str;
		this.post(str ++ "\n");
	}
	
	makeDefault {
		default = this;
	}
	
	*clearDefault { default = nil; }
	
	*post { |str|
		default.notNil.if({ default.post(str) });
	}
	
	*postln { |str|
		default.notNil.if({ default.postln(str) });
	}
}
