// Pinterp(Pwhite(...), ...) is better

PLFNoise1 : Pattern {
	var	<>lo, <>hi, <>times, <>curves, <>repeats;  // repeats == number of segments
	*new { |lo = 0.0, hi = 1.0, times = 1.0, curves = \lin, repeats = 1|
		^super.newCopyArgs(lo, hi, times, curves, repeats);
	}
	
	embedInStream { |inval|		// you can use inval as a starting value
		var	time = times.asStream,
			curve = curves.asStream;
		inval = inval ?? { rrand(lo, hi) };
		repeats.do({
			Env([inval, inval = rrand(lo, hi)], [time.next], [curve.next]).embedInStream(inval);
		});
		^inval
	}
}


Pvbrown : Pattern {
	var <>lo, <>hi, <>step, <>length;
	*new { arg lo, hi, step, length=inf;
		^super.newCopyArgs(lo, hi, step, length)
	}
	storeArgs { ^[lo,hi,step,length] }
	embedInStream { arg inval;
		var	cur = lo rrand: hi,
			stepStream = step.asStream;
		length.do({
			cur = (cur + (stepStream.value(inval) * #[-1, 1].choose)).fold(lo,hi);
			inval = cur.yield;				
		});
		^inval;
	}
}	

// access a key from the input event
Pkey : Pattern {
	var	<>key, <>repeats;
	*new { |key|
		^super.newCopyArgs(key)
	}
	storeArgs { ^[key] }
		// avoid creating a routine
	asStream {
		var	keystream = key.asStream;
		^FuncStream({ |inevent|
			inevent !? { inevent[keystream.next(inevent)] }
		});
	}
}

Pif : Pattern {
	var	<>condition, <>iftrue, <>iffalse, <>default;
	*new { |condition, iftrue, iffalse, default|
		^super.newCopyArgs(condition, iftrue, iffalse, default)
	}
	storeArgs { ^[condition, iftrue, iffalse] }
	asStream {
		var	condStream = condition.asStream,
			trueStream = iftrue.asStream,
			falseStream = iffalse.asStream;
		
		^(\FuncStreamEnvir.asClass ?? { FuncStream }).new({ |inval|
			var test;
			(test = condStream.next(inval)).isNil.if({
				nil
			}, {
				test.if({
					trueStream.next(inval) ? default
				}, {
					falseStream.next(inval) ? default
				});
			});
		}, {		// reset func
			condStream.reset;
			trueStream.reset;
			falseStream.reset;
		})
	}
}
