
// replaces .sendBundle with .listSendBundle
// to allow scheduling more complex bundles
// borrowed from felix, modified by James Harkins

OSCListSched : OSCSched {
	
	
	tsched { arg seconds,server,message,clientSideFunction;
		clock.sched(seconds - server.latency,{
			server.listSendBundle(server.latency,message);
			nil
		});
		if(clientSideFunction.notNil,{
			clock.sched(seconds,{ clientSideFunction.value; nil })
		});
	}
	xtsched { arg seconds,server,message,clientSideFunction;
		var thTask,notCancelled;
		clock.sched(seconds - server.latency,thTask = nextTask = {
			if(notCancelled = (thTask === nextTask),{
				server.listSendBundle(server.latency,message)
			});
			nil
		});
		if(clientSideFunction.notNil,{
			clock.sched(seconds,{ if(notCancelled,clientSideFunction); nil })
		});
	}

	sched { arg beats,server,message,clientSideFunction;
		tempoClock.dsched(beats - server.latency,{ // lazily using the seconds as beats
			server.listSendBundle(tempo.beats2secs(server.latency),message);
			nil
		});
		if(clientSideFunction.notNil,{
			tempoClock.dsched(beats,{ clientSideFunction.value; nil })
		});
	}
	xsched { arg beats,server,message,clientSideFunction;
		var thTask,notCancelled;
		tempoClock.dsched(beats - server.latency,thTask = nextTask = {
			if(notCancelled = (thTask === nextTask),{
				server.listSendBundle(tempo.beats2secs(server.latency),message)
			});
			nil
		});
		if(clientSideFunction.notNil,{
			tempoClock.dsched(beats,{ if(notCancelled,clientSideFunction); nil })
		});
	}
	


	// private
	tschedAbsNext  {
		var list,secs,server;
		var thTask,notCancelled;
		if((nextAbsTime = pq.topPriority).notNil,{
			list = nextAbsList = pq.pop;
			secs = nextAbsTime - this.time;
			server = list.at(0);
			clock.sched(secs - server.latency,thTask = nextAbsFunc = {
				if(notCancelled = (thTask === nextAbsFunc),{
					server.listSendBundle(server.latency,list.at(1))
				});
				nil
			});
			clock.sched(secs,{ 
				if(notCancelled,{
					list.at(2).value;
					this.tschedAbsNext;
				}); 
				nil 
			})
		});
	}
}
